﻿<?php

/*
=========================================================
 This Extension is intended for use with ExpressionEngine.
 ExpressionEngine is Copyright (c) 2003 pMachine, Inc.
 http://www.pmachine.com/
=========================================================
 THIS IS COPYRIGHTED SOFTWARE
 All RIGHTS RESERVED
 Written by: Denik
 Copyright (c) 2009 Koru Productions
 http://denik.od.ua/
--------------------------------------------------------
 Please do not distribute this extension without written
 consent from the author.
========================================================
Files:	ext.saef_captcha.php
		lang.saef_captcha.php
--------------------------------------------------------
 Purpose: 	Adds ability to captcha in the
			stand-alone entry form.
========================================================
*/

if ( ! defined('EXT'))
{
    exit('Invalid file request');
}

class Saef_captcha
{
	var $settings = array();
	var $name = 'SAEF captcha, (by Denik)';
	var $version = '1.0';
	var $description = 'This extension allows the use of captcha in the stand-alone entry form';
	var $settings_exist = 'y';
	var $docs_url = 'http://denik.od.ua/';

	function activate_extension()
	{
		global $DB;
		
		// Checking captcha
		$DB->query($DB->insert_string('exp_extensions',
				array(
				'extension_id'	=> '',
				'class'			=> get_class($this),
				'method'		=> "check_captcha",
				'hook'			=> "weblog_standalone_insert_entry",
				'settings'		=> "",
				'priority'		=> 1,
				'version'		=> $this->version,
				'enabled'		=> "y"
				)
			)
		);
		
		// Generate captcha
		$DB->query($DB->insert_string('exp_extensions',
				array(
				'extension_id'	=> '',
				'class'			=> get_class($this),
				'method'		=> "genere_captcha",
				'hook'			=> "weblog_standalone_form_start",
				'settings'		=> "",
				'priority'		=> 1,
				'version'		=> $this->version,
				'enabled'		=> "y"
				)
			)
		);
	}
		
	function disable_extension()
	{
		global $DB;
		
		$DB->query("DELETE FROM exp_extensions WHERE class = '".get_class($this)."'");
	}

	
	// CONSTRUCTOR
	function Saef_captcha($settings='')
	{
		$this->settings = $settings;
	}
	
	// -----------------------------
	// Change Settings
	// -----------------------------
	function settings()
	{
		global $PREFS;
		
		$settings = array();
		$settings['welcome'] = array("");
		$settings['weblogs'] = "";

		return $settings;
	}
	
	// Checking captcha
	function check_captcha()
	{
		GLOBAL $DB, $LANG, $OUT, $IN, $EXT;

		$weblogs = explode(",", $this->settings['weblogs']);
		foreach( $weblogs as $k=>$v ) $weblogs[$k] = trim($v);
		
		if( isset($_POST['weblog_id']) && $_POST['weblog_id']>0 && in_array($_POST['weblog_id'], $weblogs) )
		{
			// Captcha:
			if ( ! isset($_POST['captcha']) || $_POST['captcha'] == '')
			{
				return $OUT->show_user_error('submission', $LANG->line('captcha_required'));
				$EXT->end_script = TRUE;
			}
			else
			{
				$res = $DB->query("SELECT COUNT(*) AS count FROM exp_captcha WHERE word='".$DB->escape_str($_POST['captcha'])."' AND ip_address = '".$IN->IP."' AND date > UNIX_TIMESTAMP()-7200");
			
				if ($res->row['count'] == 0)
				{
					return $OUT->show_user_error('submission', $LANG->line('captcha_incorrect'));
					$EXT->end_script = TRUE;
				}
			
				$DB->query("DELETE FROM exp_captcha WHERE (word='".$DB->escape_str($_POST['captcha'])."' AND ip_address = '".$IN->IP."') OR date < UNIX_TIMESTAMP()-7200");
			}
		}
	}
	
	// Generate captcha
	function genere_captcha($return_form, $captcha, $weblog_id)
	{
		GLOBAL $TMPL, $FNS, $EXT;
		
		$weblogs = explode(",", $this->settings['weblogs']);
		foreach( $weblogs as $k=>$v ) $weblogs[$k] = trim($v);
		
		if( in_array($weblog_id, $weblogs) )
		{
			$TMPL->tagdata = str_replace(LD.'captcha'.RD, $FNS->create_captcha(), $TMPL->tagdata);
			$TMPL->tagdata = $FNS->prep_conditionals($TMPL->tagdata, array('captcha'=>'TRUE'));
			$EXT->end_script = FALSE;
		}
	}
}
?>